#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue



//extern ENUM_TIMEFRAMES    TimeFrame     = PERIOD_CURRENT; // Time frame to use
extern string    TimeFrame     = PERIOD_CURRENT; // Time frame to use

extern bool EachTickMode = False;
extern int FastMAPeriod = 1;
extern int SlowMAPeriod = 34;
extern int  Signalperiod = 5;
extern string note            = "turn on Alert = true; turn off = false";
extern bool   alertsOn        = true;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = true;
extern bool   alertsEmail     = false;
extern bool   alertsNotify    = false;
extern string soundfile       = "alert2.wav";

double      Buffer1[],
            Buffer2[],
            b2[],
            b3[];
double      trend[];           
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   
      
if (TimeFrame == -1)
      switch(Period())
      {
         case 1:     TimeFrame = 5 ;     break;
         case 5:     TimeFrame = 15 ;    break;
         case 15:    TimeFrame = 30 ;    break;
         case 30:    TimeFrame = 60 ;    break;
         case 60:    TimeFrame = 240 ;   break;
         case 240:   TimeFrame = 1440 ;  break;
         case 1440:  TimeFrame = 10080 ; break;
         case 10080: TimeFrame = 43200 ; break;
         default :   TimeFrame = Period();
      }
   
   IndicatorBuffers(5);
   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,3);
   SetIndexArrow(0,242);  
   SetIndexBuffer(0,b2);
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,3);
   SetIndexArrow(1,241);   
   SetIndexBuffer(1,b3);
   SetIndexBuffer(2,Buffer1);
   SetIndexBuffer(3,Buffer2);
   SetIndexBuffer(4,trend);
         indicatorFileName = WindowExpertName();
         returnBars        = TimeFrame==-99;
         TimeFrame         = MathMax(TimeFrame,_Period);
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (TimeFrame!=Period())
         {
            limit = (int)MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
            for (i=limit; i>=0; i--)
            {
               int y = iBarShift(NULL,TimeFrame,Time[i]);               
                  b2[i] = EMPTY_VALUE;
                  b3[i] = EMPTY_VALUE;
                  trend[i]  = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,false,FastMAPeriod,SlowMAPeriod,Signalperiod,"",alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,alertsNotify,soundfile,4,y);
                     if (trend[i] !=trend[i+1])
                     if (trend[i] == 1)
                           b3[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
                     else  b2[i] = High[i]+ iATR(NULL,0,20,i)/2.0;
            }
            return(0);
         }            
     
      
   for(i=limit; i>=0; i--) Buffer1[i]= iMA(NULL,0,FastMAPeriod,0,MODE_SMA,PRICE_MEDIAN,i)-iMA(NULL,0,SlowMAPeriod,0,MODE_SMA,PRICE_MEDIAN,i);       
   for(i=limit; i>=0; i--) Buffer2[i]= iMAOnArray(Buffer1,0,Signalperiod,0,MODE_LWMA,i);
   for(i=limit; i>=0; i--)
   {
      trend[i] = trend[i+1];
      if(Buffer1[i]>Buffer2[i]) trend[i] = 1;
      if(Buffer1[i]<Buffer2[i]) trend[i] =-1;
         
      //
      //
      //
      //
      //
      
      b2[i] = EMPTY_VALUE;
      b3[i] = EMPTY_VALUE;
      if (trend[i] !=trend[i+1])
      if (trend[i] == 1)
            b3[i] = Low[i] - iATR(NULL,0,20,i)/2.0;
      else  b2[i] = High[i]+ iATR(NULL,0,20,i)/2.0;
      }
         
         //
         //
         //
         //
         //
         
         if (alertsOn)
         {
           if (alertsOnCurrent)
                int whichBar = 0;
           else     whichBar = 1;
         
           if (trend[whichBar] != trend[whichBar+1])
           if (trend[whichBar] == 1)
                 doAlert("uptrend");
           else  doAlert("downtrend");       
        }
   return(0);
}

//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," SmaCrossOver ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol()," SmaCrossOver "),message);
             if (alertsNotify)  SendNotification(StringConcatenate(Symbol(), Period() ," SmaCrossOver " +" "+message));
             if (alertsSound)   PlaySound(soundfile);
      }
}
